"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class Part(google.protobuf.message.Message):
    """Part definition, a Part is related to a CAD part file (scdocx, prt, ...) made of meshed bodies and faces"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class PartInstance(google.protobuf.message.Message):
        """Instance of Part in parent coordinates system"""
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        NAME_FIELD_NUMBER: builtins.int
        DESCRIPTION_FIELD_NUMBER: builtins.int
        PART_GUID_FIELD_NUMBER: builtins.int
        AXIS_SYSTEM_FIELD_NUMBER: builtins.int
        name: typing.Text = ...
        description: typing.Text = ...
        part_guid: typing.Text = ...
        """Guid of Part in PartsManager"""

        @property
        def axis_system(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
            """Part position relative to parent reference (Ox Oy Oz Xx Xy Xz Yx Yy Yz Zx Zy Zz)"""
            pass
        def __init__(self,
            *,
            name : typing.Text = ...,
            description : typing.Text = ...,
            part_guid : typing.Text = ...,
            axis_system : typing.Optional[typing.Iterable[builtins.float]] = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["axis_system",b"axis_system","description",b"description","name",b"name","part_guid",b"part_guid"]) -> None: ...

    class MetadataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: typing.Text = ...
        value: typing.Text = ...
        def __init__(self,
            *,
            key : typing.Text = ...,
            value : typing.Text = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["key",b"key","value",b"value"]) -> None: ...

    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    BODY_GUIDS_FIELD_NUMBER: builtins.int
    PARTS_FIELD_NUMBER: builtins.int
    name: typing.Text = ...
    description: typing.Text = ...
    @property
    def metadata(self) -> google.protobuf.internal.containers.ScalarMap[typing.Text, typing.Text]:
        """User defined metadata"""
        pass
    @property
    def body_guids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """List of bodies constituting the part"""
        pass
    @property
    def parts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Part.PartInstance]:
        """List of sub parts"""
        pass
    def __init__(self,
        *,
        name : typing.Text = ...,
        description : typing.Text = ...,
        metadata : typing.Optional[typing.Mapping[typing.Text, typing.Text]] = ...,
        body_guids : typing.Optional[typing.Iterable[typing.Text]] = ...,
        parts : typing.Optional[typing.Iterable[global___Part.PartInstance]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["body_guids",b"body_guids","description",b"description","metadata",b"metadata","name",b"name","parts",b"parts"]) -> None: ...
global___Part = Part

class Create_Request(google.protobuf.message.Message):
    """Request to create an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PART_FIELD_NUMBER: builtins.int
    @property
    def part(self) -> global___Part:
        """Element to create"""
        pass
    def __init__(self,
        *,
        part : typing.Optional[global___Part] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["part",b"part"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["part",b"part"]) -> None: ...
global___Create_Request = Create_Request

class Create_Response(google.protobuf.message.Message):
    """Response to create an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the created element"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Create_Response = Create_Response

class Read_Request(google.protobuf.message.Message):
    """Request to read an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the element to be read"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Read_Request = Read_Request

class Read_Response(google.protobuf.message.Message):
    """Response to read an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PART_FIELD_NUMBER: builtins.int
    @property
    def part(self) -> global___Part:
        """Element corresponding to the guid given in Read_Request"""
        pass
    def __init__(self,
        *,
        part : typing.Optional[global___Part] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["part",b"part"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["part",b"part"]) -> None: ...
global___Read_Response = Read_Response

class Update_Request(google.protobuf.message.Message):
    """Request to update an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    PART_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the PartTemplate to be updated"""

    @property
    def part(self) -> global___Part:
        """New element that will be used for the update"""
        pass
    def __init__(self,
        *,
        guid : typing.Text = ...,
        part : typing.Optional[global___Part] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["part",b"part"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid","part",b"part"]) -> None: ...
global___Update_Request = Update_Request

class Update_Response(google.protobuf.message.Message):
    """Response to update an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___Update_Response = Update_Response

class Delete_Request(google.protobuf.message.Message):
    """Request to delete an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the element to be deleted"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Delete_Request = Delete_Request

class Delete_Response(google.protobuf.message.Message):
    """Response to delete an element"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___Delete_Response = Delete_Response

class List_Request(google.protobuf.message.Message):
    """Request to list all elements"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___List_Request = List_Request

class List_Response(google.protobuf.message.Message):
    """Response to list all elements"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUIDS_FIELD_NUMBER: builtins.int
    @property
    def guids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """Guids of all Parts"""
        pass
    def __init__(self,
        *,
        guids : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guids",b"guids"]) -> None: ...
global___List_Response = List_Response

class ReadAll_Request(google.protobuf.message.Message):
    """Request to read all parts"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___ReadAll_Request = ReadAll_Request

class ReadAll_Response(google.protobuf.message.Message):
    """Response to read all parts"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class PartsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: typing.Text = ...
        @property
        def value(self) -> global___Part: ...
        def __init__(self,
            *,
            key : typing.Text = ...,
            value : typing.Optional[global___Part] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["value",b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["key",b"key","value",b"value"]) -> None: ...

    PARTS_FIELD_NUMBER: builtins.int
    @property
    def parts(self) -> google.protobuf.internal.containers.MessageMap[typing.Text, global___Part]:
        """Read parts with their Guids"""
        pass
    def __init__(self,
        *,
        parts : typing.Optional[typing.Mapping[typing.Text, global___Part]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["parts",b"parts"]) -> None: ...
global___ReadAll_Response = ReadAll_Response
