"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class VOPTemplate(google.protobuf.message.Message):
    """VOP: Volume Optical Properties
    Defines the behavior of light rays when they are propagated in a body.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class Opaque(google.protobuf.message.Message):
        """Non-transparent material"""
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        def __init__(self,
            ) -> None: ...

    class Optic(google.protobuf.message.Message):
        """Transparent colorless material without bulk scattering"""
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        INDEX_FIELD_NUMBER: builtins.int
        ABSORPTION_FIELD_NUMBER: builtins.int
        CONSTRINGENCE_FIELD_NUMBER: builtins.int
        index: builtins.float = ...
        """Refractive index"""

        absorption: builtins.float = ...
        constringence: builtins.float = ...
        """Abbe number"""

        def __init__(self,
            *,
            index : builtins.float = ...,
            absorption : builtins.float = ...,
            constringence : typing.Optional[builtins.float] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["_constringence",b"_constringence","constringence",b"constringence"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["_constringence",b"_constringence","absorption",b"absorption","constringence",b"constringence","index",b"index"]) -> None: ...
        def WhichOneof(self, oneof_group: typing_extensions.Literal["_constringence",b"_constringence"]) -> typing.Optional[typing_extensions.Literal["constringence"]]: ...

    class Library(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        MATERIAL_FILE_URI_FIELD_NUMBER: builtins.int
        material_file_uri: typing.Text = ...
        """*.material file"""

        def __init__(self,
            *,
            material_file_uri : typing.Text = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["material_file_uri",b"material_file_uri"]) -> None: ...

    class NonHomogeneous(google.protobuf.message.Message):
        """Material with non-homogeneous refractive index"""
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        GRADEDMATERIAL_FILE_URI_FIELD_NUMBER: builtins.int
        gradedmaterial_file_uri: typing.Text = ...
        """*.gradedmaterial file that describes the spectral variations of refractive index and absorption with respect to position in space"""

        def __init__(self,
            *,
            gradedmaterial_file_uri : typing.Text = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["gradedmaterial_file_uri",b"gradedmaterial_file_uri"]) -> None: ...

    class MetadataEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: typing.Text = ...
        value: typing.Text = ...
        def __init__(self,
            *,
            key : typing.Text = ...,
            value : typing.Text = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["key",b"key","value",b"value"]) -> None: ...

    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    METADATA_FIELD_NUMBER: builtins.int
    OPAQUE_FIELD_NUMBER: builtins.int
    OPTIC_FIELD_NUMBER: builtins.int
    LIBRARY_FIELD_NUMBER: builtins.int
    NON_HOMOGENEOUS_FIELD_NUMBER: builtins.int
    name: typing.Text = ...
    """VOPTemplate name"""

    description: typing.Text = ...
    """VOPTemplate description"""

    @property
    def metadata(self) -> google.protobuf.internal.containers.ScalarMap[typing.Text, typing.Text]:
        """User defined metadatas"""
        pass
    @property
    def opaque(self) -> global___VOPTemplate.Opaque:
        """Non-transparent material"""
        pass
    @property
    def optic(self) -> global___VOPTemplate.Optic:
        """Transparent colorless material without bulk scattering"""
        pass
    @property
    def library(self) -> global___VOPTemplate.Library:
        """Based on *.material file"""
        pass
    @property
    def non_homogeneous(self) -> global___VOPTemplate.NonHomogeneous:
        """Material with non-homogeneous refractive index"""
        pass
    def __init__(self,
        *,
        name : typing.Text = ...,
        description : typing.Text = ...,
        metadata : typing.Optional[typing.Mapping[typing.Text, typing.Text]] = ...,
        opaque : typing.Optional[global___VOPTemplate.Opaque] = ...,
        optic : typing.Optional[global___VOPTemplate.Optic] = ...,
        library : typing.Optional[global___VOPTemplate.Library] = ...,
        non_homogeneous : typing.Optional[global___VOPTemplate.NonHomogeneous] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["library",b"library","non_homogeneous",b"non_homogeneous","opaque",b"opaque","optic",b"optic","type",b"type"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["description",b"description","library",b"library","metadata",b"metadata","name",b"name","non_homogeneous",b"non_homogeneous","opaque",b"opaque","optic",b"optic","type",b"type"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["type",b"type"]) -> typing.Optional[typing_extensions.Literal["opaque","optic","library","non_homogeneous"]]: ...
global___VOPTemplate = VOPTemplate

class Create_Request(google.protobuf.message.Message):
    """Request to create a VOPTemplate in VOPTemplatesManager"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VOP_TEMPLATE_FIELD_NUMBER: builtins.int
    @property
    def vop_template(self) -> global___VOPTemplate:
        """VOPTemplate containing its basic characteristics"""
        pass
    def __init__(self,
        *,
        vop_template : typing.Optional[global___VOPTemplate] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vop_template",b"vop_template"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["vop_template",b"vop_template"]) -> None: ...
global___Create_Request = Create_Request

class Create_Response(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the VOPTemplate created in VOPTemplatesManager"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Create_Response = Create_Response

class Read_Request(google.protobuf.message.Message):
    """Request to read a VOPTemplate in VOPTemplatesManager"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the VOPTemplate to be read"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Read_Request = Read_Request

class Read_Response(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    VOP_TEMPLATE_FIELD_NUMBER: builtins.int
    @property
    def vop_template(self) -> global___VOPTemplate:
        """VOPTemplate corresponding to the guid given in Read_Request"""
        pass
    def __init__(self,
        *,
        vop_template : typing.Optional[global___VOPTemplate] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vop_template",b"vop_template"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["vop_template",b"vop_template"]) -> None: ...
global___Read_Response = Read_Response

class Update_Request(google.protobuf.message.Message):
    """Request to update a VOPTemplate in VOPTemplatesManager"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    VOP_TEMPLATE_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the VOPTemplate to be updated"""

    @property
    def vop_template(self) -> global___VOPTemplate:
        """VOPTemplate that will be used for the update"""
        pass
    def __init__(self,
        *,
        guid : typing.Text = ...,
        vop_template : typing.Optional[global___VOPTemplate] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["vop_template",b"vop_template"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid","vop_template",b"vop_template"]) -> None: ...
global___Update_Request = Update_Request

class Update_Response(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___Update_Response = Update_Response

class Delete_Request(google.protobuf.message.Message):
    """Request to delete a VOPTemplate in VOPTemplatesManager"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUID_FIELD_NUMBER: builtins.int
    guid: typing.Text = ...
    """Guid of the VOPTemplate to be deleted"""

    def __init__(self,
        *,
        guid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guid",b"guid"]) -> None: ...
global___Delete_Request = Delete_Request

class Delete_Response(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___Delete_Response = Delete_Response

class List_Request(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    def __init__(self,
        ) -> None: ...
global___List_Request = List_Request

class List_Response(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    GUIDS_FIELD_NUMBER: builtins.int
    @property
    def guids(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[typing.Text]:
        """Guids of the VOPTemplates in VOPTemplatesManager"""
        pass
    def __init__(self,
        *,
        guids : typing.Optional[typing.Iterable[typing.Text]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["guids",b"guids"]) -> None: ...
global___List_Response = List_Response
